//All the functions that Xbase supports are here. You are advised not to edit this file as it could break scripting.
//However, you are free to look over it to see what functions Xbase supports.

//*** The tools class provides general things that javascript missed out (multi-button alerts for instance) ***
var Tools = function() {}

/*
 @deprecated in 1.0.4: Use Tools.Alert or the Alert class;
*/
Tools.ChoiceAlert = function(title, message, mainButton, secondaryButton, otherButton)
{
	return Tools.Alert(title,message, mainButton, secondaryButton, otherButton);
}
Tools.ChoiceAlert.Default = "Default";
Tools.ChoiceAlert.Secondary = "Secondary";
Tools.ChoiceAlert.Third = "Third";
Tools.ChoiceAlert.Error = "Error";

Tools.Log = function(message) { Log(message); }
Tools.Print = function(message) { Log.Print(message); }

/*
 @end-deprecated;
 */




//@version: 1.0.4;

Tools.Beep = function(soundName) { window.XbaseController.xwBeep_(soundName); }
Tools.Alert = function(title, message, mainButton, secondaryButton, otherButton) {	
	var a = new Alert;
	a.title = title;
	a.message = message;
	a.mainButton = mainButton;
	a.secondaryButton = secondaryButton;
	a.otherButton = otherButton;
	
	a.show();
	
	return a.selectedButton;
}

Tools.TextAlert = function(title, message, mainButton, secondaryButton, otherButton) {
	var a = new Alert;
	a.title = title;
	a.message = message;
	a.mainButton = mainButton;
	a.secondaryButton = secondaryButton;
	a.otherButton = otherButton;
	
	a.hasTextField = true;
	
	a.show();
	var resObject = { button:a.selectedButton, text:a.textFieldValue };
	return resObject;
}
function Alert() {
	this.title = "";
	this.message = "";
	this.mainButton = "";
	this.secondaryButton = "";
	this.otherButton = "";
	this.hasTextField = false;
	this.textFieldValue = "";
} 
Alert.prototype.show = function() {
	window.XbaseController.xwAlertShow_(this);
	return this.selectedButton;
}
Alert.MainButton = "Default";
Alert.SecondaryButton = "Secondary";
Alert.OtherButton = "Third";
Alert.ErrorResult = "Error"; 

Log = function(message) { window.XbaseController.xwLog_(message); }
Log.Print = function(message) { window.XbaseController.xwPrint_(message); }
Log.PrintError = function(message) { window.XbaseController.xwPrintError_(message); }
Log.Clear = function() { window.XbaseController.xwClearLog(); } 
Log.ClearAll = function() { window.XbaseController.xwClearAllLogs(); } 
Log.__defineGetter__("Text", function() { return window.XbaseController.xwGetLogText() });
Log.__defineGetter__("Contents", function() { return Wka2Jsa(window.XbaseController.xwGetLogContents()) });

Tools.StopScript = function() { window.XbaseController.xwStopScriptExecution(); };


function EmailMessage() {
	this.to = ""; //Required
	this.subject = "";
	this.from = "";
	this.body = "";
	this.bcc = "";
	this.cc = "";
	this.replyto = "";
} 
EmailMessage.prototype.send = function() {
	
	if (typeof(this.to) != "string")
		this.to = this.to.join(", ");
	if (typeof(this.bcc) != "string")
		this.bcc = this.bcc.join(", ");
	if (typeof(this.cc) != "string")
		this.cc = this.cc.join(", ");
	
	window.XbaseController.xwSendEmailMessage_(this);
	return this.selectedButton;
}

Tools.SendEmail = function(to, subject, body, from) { 
	var emailMsg = new EmailMessage();
	emailMsg.to = to;
	emailMsg.subject = subject;
	emailMsg.body = body;
	emailMsg.from = from;
	
	emailMsg.send();
}

//@end-version: 1.0.4;



//@version: 1.1;

Tools.Random = function(min, max)
{
	return Math.floor(Math.random() * (max - min + 1)) + min;
}

Tools.RandomFloat = function(min, max)
{
	return Math.random() * (max - min + 1) + min;
}

Tools.GenerateUUID = function(min, max)
{
	return window.XbaseController.xwGenerateUUID();
}

//@end-version: 1.1;


//---------------------
//*** XBASE Class ***
//---------------------

var Xbase = function() {}
Xbase.Quit = function(message) { window.XbaseController.xwQuit(); }
Xbase.Hide = function(message) { window.XbaseController.xwHide(); }
Xbase.HideOthers = function(message) { window.XbaseController.xwHideOthers(); }
Xbase.BringToFront = function(message) { window.XbaseController.xwBringToFront(); }
Xbase.SetPreference = function(key, value) { window.XbaseController.xwSetPreference__(key, value); }
Xbase.GetPreference = function(key) { return window.XbaseController.xwGetPreference_(key); }
Xbase.Version = window.XbaseController.xwXbaseVersion();



//---------------------
//*** DOCUMENT Class ***
//---------------------

var Document = function() {}
Document.Close = function(shouldSave) { window.XbaseController.xwClose_(shouldSave) }
Document.Save = function() { window.XbaseController.xwSave() }
Document.Minimize = function() { window.XbaseController.xwMinimize() }
Document.Deminimize = function() { window.XbaseController.xwDeminimize() }
Document.Zoom = function() { window.XbaseController.xwZoom() }
Document.PrintReport = function(reportName) { return window.XbaseController.xwPrintReport_(reportName) }
Document.RunScript = function(scriptName) { return window.XbaseController.xwRunScript_(scriptName) }
Document.Formula = function(f) { return window.XbaseController.xwEvaluateFormula__(null, f) }

//@version: 1.0.4;

Document.Shake = function() { window.XbaseController.xwShakeWindow(); }
Document.MarkAsNeedingChanges = function() { window.XbaseController.xwMarkAsNeedingChanges(); }

//@end-version: 1.0.4;


//PRIVATE function
function Wka2Jsa(arr)
{
	if ((typeof arr) == "undefined")
		return null;
	if (arr == null)
		return null;
	
	var a = new Array();
	for (i = 0; i < arr.length; i++)
	{
		a.push(arr[i]);
	}
	return a;
}



//---------------------
//*** CONTROL Class ***
//---------------------

var Rect = function(x, y, width, height) {
	this.x = 0.0;
	this.y = 0.0;
	this.width = 0.0;
	this.height = 0.0;
	
	if ((typeof x) != "undefined")
		this.x = x;
	if ((typeof y) != "undefined")
		this.y = y;
	if ((typeof width) != "undefined")
		this.width = width;
	if ((typeof height) != "undefined")
		this.height = height;
}

var ControlAnimator = function(n) {
	this.name = n;
	
	this.__defineGetter__("rect", function() { r = new Rect(); r = window.XbaseController.xwFormControlFrame__(this.name, r); return r; });
	this.__defineSetter__("rect", function(x) { window.XbaseController.xwFormSetControlFrameAnimate__(this.name, x); });
	
	this.__defineGetter__("visible", function() { return window.XbaseController.xwFormIsControlVisible_(this.name); });
	this.__defineSetter__("visible", function(x) { window.XbaseController.xwFormSetControlVisibilityAnimate__(this.name, x); });
}

var Control = function(n) {
	this.name = n;
	
	this.__defineGetter__("value", function() { return window.XbaseController.xwFormControlValue_(this.name); });
	this.__defineSetter__("value", function(x) { window.XbaseController.xwFormSetControlValue__(this.name, x); });
	
	this.__defineGetter__("numValue", function() { return Number(window.XbaseController.xwFormControlValue_(this.name)); });
	this.__defineSetter__("numValue", function(x) { window.XbaseController.xwFormSetControlValue__(this.name, String(x)); });
	
	this.__defineGetter__("tooltip", function() { return this.attr("Tooltip"); });
	this.__defineSetter__("tooltip", function(x) { this.setAttr("Tooltip", x); });
	
	this.__defineGetter__("enabled", function() { return this.attr("Enabled"); });
	this.__defineSetter__("enabled", function(x) { this.setAttr("Enabled", x); });
	
	this.__defineGetter__("visible", function() { return window.XbaseController.xwFormIsControlVisible_(this.name); });
	this.__defineSetter__("visible", function(x) { window.XbaseController.xwFormSetControlVisibility__(this.name, x); });
	
	this.__defineGetter__("label", function() { return this.attr("Label"); });
	this.__defineSetter__("label", function(x) { this.setAttr("Label", x); });
	
	this.__defineGetter__("label", function() { return this.attr("Label"); });
	this.__defineSetter__("label", function(x) { this.setAttr("Label", x); });
	
	this.__defineGetter__("rect", function() { r = new Rect(); r = window.XbaseController.xwFormControlFrame__(this.name, r); return r; });
	this.__defineSetter__("rect", function(x) { window.XbaseController.xwFormSetControlFrame__(this.name, x); });
	
	this.attr = function(propertyName)
	{
		return window.XbaseController.xwFormGetControlAttribute__(this.name,propertyName);
	}
	this.setAttr = function (propertyName, newValue)
	{
		window.XbaseController.xwFormSetControlAttribute___(this.name,propertyName,newValue);
	}
	
	this.__defineGetter__("animator", function() { return new ControlAnimator(this.name); });

};



//---------------------
//*** FORM Class ***
//---------------------

var Form = function() {}

var formControlNames = Wka2Jsa(window.XbaseController.xwFormControlNames());
if (formControlNames && formControlNames.length)
{
	for (var i = 0; i < formControlNames.length; i++)
	{
		Form[formControlNames[i]] = new Control(formControlNames[i]);
	}
}


Form.ControlNamed = function(n) {
	var controlObject = new Control(n);	
	return controlObject;
}

/*
 @deprecated in 1.0.4: Use Tools.Alert or the Alert class;
 */

Form.SetGlobal = function(key, value) { window.XbaseController.xwFormSetGlobal__(key, value); }
Form.GetGlobal = function(key) { return window.XbaseController.xwFormGetGlobal_(key); }

Form.Rowid = function() { return window.XbaseController.xwFormCurrentRowid(); }
Form.LastEditedField = function() { return window.XbaseController.xwFormCurrentLastEditedField(); }
Form.ContentTable = function() { return window.XbaseController.xwFormContentTable(); }
Form.ControlNames = function() { return Wka2Jsa(window.XbaseController.xwFormControlNames()); }
Form.Name = function() { return window.XbaseController.xwFormName(); }

/*
 @end-deprecated;
 */

Form.setGlobal = function(key, value) { window.XbaseController.xwFormSetGlobal__(key, value); }
Form.getGlobal = function(key) { return window.XbaseController.xwFormGetGlobal_(key); }

Form.__defineGetter__("rowid", function() { return window.XbaseController.xwFormCurrentRowid(); });
Form.__defineGetter__("lastEditedField", function() { return window.XbaseController.xwFormCurrentLastEditedField(); });
Form.__defineGetter__("contentTable", function() { return window.XbaseController.xwFormContentTable(); });
Form.__defineGetter__("controlNames", function() { return Wka2Jsa(window.XbaseController.xwFormControlNames()); });
Form.__defineGetter__("name", function() { return window.XbaseController.xwFormName(); });
Form.__defineGetter__("width", function() { return window.XbaseController.xwFormProperty_("Width"); });
Form.__defineGetter__("height", function() { return window.XbaseController.xwFormProperty_("Height"); });


//---------------------
//*** DATA Class ***
//---------------------

var Data = function() {}
Data.TableNames = function() { return Wka2Jsa(window.XbaseController.xwTableNames()); }
Data.TypeForTableField = function (tableName, fieldName) { return window.XbaseController.xwDatatypeForTable_field_(tableName, fieldName) };
Data.FieldNamesForTable = function(tableName) { return Wka2Jsa(window.XbaseController.xwFieldNamesForTable_(tableName)) }
Data.NumRows = function (tableName) { return window.XbaseController.xwRowCountForTable_(tableName) }
Data.ValuesArray = function(tableName, fieldName) { return Wka2Jsa(window.XbaseController.xwDataValuesArray__(tableName, fieldName)) }
Data.IndexOfID = function(table, rowid) { return window.XbaseController.xwIndexOfID__(table, rowid) }
Data.IDAtIndex = function(table, index) { return window.XbaseController.xwIDAtIndex__(table, index) }
Data.ValueAtIndex = function(tableName, fieldName, index) {
	return Data.ValueWithID(tableName, fieldName, Data.IDAtIndex(tableName, index));
}
Data.ValueWithID = function(tableName, fieldName, rowid) {
	var datatype___ = Data.TypeForTableField(tableName, fieldName);
	var value___ = window.XbaseController.xwDataValue___(tableName, fieldName, rowid);
	
	if (datatype___ == "Date")
	{
		var date___ = new Date();
		date___.setTime(value___ * 1000.0);
		return date___;
	}
	
	return value___; 
}

Data.SetValueAtIndex = function(tableName, fieldName, index, newValue) { return window.XbaseController.xwSetDataValue____(tableName, fieldName, Data.IDAtIndex(tableName,index), newValue) }
Data.SetValueWithID = function(tableName, fieldName, rowid, newValue) { return window.XbaseController.xwSetDataValue____(tableName, fieldName, rowid, newValue) }

Data.AddRowAtEnd = function(tableName) { return window.XbaseController.xwAddRowAtEnd_(tableName) }
Data.RemoveRowAtIndex = function(tableName, index) { return window.XbaseController.xwRemoveRowWithID__(tableName, Data.IDAtIndex(tableName, index)) }
Data.RemoveRowWithID = function(tableName, rowid) { return window.XbaseController.xwRemoveRowWithID__(tableName, rowid) }



//---------------------
//*** FIELD Class ***
//---------------------

function Field(tableName, fieldName)
{
	if (typeof tableName != "undefined")
		this.tableName = tableName;
	else
		this.tableName = null;
	
	if (typeof fieldName != "undefined")
		this.name = fieldName;
	else
		this.name = null;
		
	this.__defineGetter__("numRows", function() { return Data.NumRows(this.tableName); });
	this.__defineGetter__("datatype", function() { return Data.TypeForTableField(this.tableName, this.name); });

	this.value = function(index) { return Data.ValueAtIndex(this.tableName, this.name, index); }
	this.setValue = function(index, newValue) { return Data.SetValueAtIndex(this.tableName, this.name, index, newValue); }
}



//---------------------
//*** TABLE Class ***
//---------------------

function Table(name)
{
	if (typeof name != "undefined")
		this.name = name;
	else
		this.name = null;
	
	//Set up the [] operator
	if (this.name != null)
	{
		var fieldNames = Data.FieldNamesForTable(this.name);
		
		if (fieldNames && fieldNames.length)
		{
			for (var i in fieldNames)
			{
				this[fieldNames[i]] = new Field(this.name, fieldNames[i]);
			}
		}
	}
	
	this.indexOfID = function(rowid) { return Data.IndexOfID(this.name, rowid); }
	this.IDAtIndex = function(index) { return Data.IDAtIndex(this.name, index); }
	
	this.__defineGetter__("fieldNames", function() { return Data.FieldNamesForTable(this.name); });
	this.typeForField = function(field) { return Data.TypeForTableField(this.name, field); }
	
	this.__defineGetter__("numRows", function() { return Data.NumRows(this.name); });
	
	this.valuesArray = function(field) { return Data.ValuesArray(this.name, field); }
	this.valueAtIndex = function(field, index) { return Data.ValueAtIndex(this.name, field, index); }
	this.valueWithID = function(field, rowid) { return Data.ValueWithID(this.name, field, rowid); }
	
	this.setValueAtIndex = function(field, index, newValue) { Data.SetValueAtIndex(this.name, field, index, newValue); }
	this.setValueWithID = function(field, rowid, newValue) { Data.SetValueWithID(this.name, field, rowid, newValue); }
	
	this.removeRowAtIndex = function(index) { return Data.RemoveRowAtIndex(this.name, index); }
	this.removeRowWithID = function(rowid) { return Data.RemoveRowWithID(this.name, rowid); }
	
	this.addRow = function() { return Data.AddRowAtEnd(this.name); }
}

var dataTableNames = Data.TableNames();
if (dataTableNames && dataTableNames.length)
{
	for (var i in dataTableNames)
	{
		Data[dataTableNames[i]] = new Table(dataTableNames[i]);
	}
}
